apiVersion: apps/v1
kind: Deployment
metadata:
  name: registry-mirror
spec:
  replicas: 1
  strategy:
    type: Recreate
  selector:
    matchLabels:
      name: registry-mirror
  template:
    metadata:
      labels:
        name: registry-mirror
    spec:
      containers:
        - name: registry
          image: docker.io/library/registry:2.8.3@sha256:a3d8aaa63ed8681a604f1dea0aa03f100d5895b6a58ace528858a7b332415373
          env:
            - name: REGISTRY_STORAGE_S3_ACCESSKEY
              valueFrom:
                secretKeyRef:
                  name: registry-mirror-bucket
                  key: AWS_ACCESS_KEY_ID
            - name: REGISTRY_STORAGE_S3_SECRETKEY
              valueFrom:
                secretKeyRef:
                  name: registry-mirror-bucket
                  key: AWS_SECRET_ACCESS_KEY
            - name: REGISTRY_STORAGE_S3_BUCKET
              valueFrom:
                configMapKeyRef:
                  name: registry-mirror-bucket
                  key: BUCKET_NAME
          resources:
            limits:
              cpu: 1000m
              memory: "500Mi"
            requests:
              cpu: "100m"
              memory: "500Mi"
          livenessProbe:
            httpGet:
              path: /v2/
              port: 5000
          readinessProbe:
            httpGet:
              path: /v2/_catalog?n=1
              port: 5000
          lifecycle:
            preStop:
              exec:
                command:
                  - sh
                  - -c
                  - "sleep 10"
          volumeMounts:
            - name: config
              mountPath: /etc/docker/registry/
          ports:
            - containerPort: 5000
              name: registry
              protocol: TCP
      volumes:
        - name: config
          secret:
            secretName: registry-mirror-config
      affinity:
        podAntiAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
            - labelSelector:
                matchExpressions:
                  - key: name
                    operator: In
                    values:
                      - registry-mirror
              topologyKey: "kubernetes.io/hostname"
